SPDX-License-Identifier: CC-BY-SA-4.0 OR BSD-2-Clause
brief: |
  Fires the timer at the time of day using the Timer Server.
copyrights:
- Copyright (C) 2020 embedded brains GmbH (http://www.embedded-brains.de)
- Copyright (C) 1988, 2008 On-Line Applications Research Corporation (OAR)
definition:
  default:
    attributes: null
    body: null
    params:
    - ${../../type/if/id:/name} ${.:/params[0]/name}
    - ${../../type/if/time-of-day:/name} *${.:/params[1]/name}
    - ${service-routine-entry:/name} ${.:/params[2]/name}
    - void *${.:/params[3]/name}
    return: ${../../status/if/code:/name}
  variants: []
description: |
  This directive initiates the timer specified by ${.:/params[0]/name}.  If the
  timer is running, it is automatically canceled before being initiated.  The
  timer is scheduled to fire at the time of day specified by
  ${.:/params[1]/name}.  When the timer fires, the timer service routine
  ${.:/params[2]/name} will be invoked with the argument ${.:/params[3]/name}
  in the context of the Timer Server task.
enabled-by: true
index-entries:
- fire a task-based timer at time of day
interface-type: function
links:
- role: interface-placement
  uid: header
- role: interface-ingroup
  uid: group
name: rtems_timer_server_fire_when
notes: |
  This directive will not cause the running task to be preempted.
params:
- description: is the timer identifier.
  dir: null
  name: id
- description: is the time of day when the routine is fired.
  dir: null
  name: wall_time
- description: is the routine to schedule.
  dir: null
  name: routine
- description: is the argument passed to the routine when it is fired.
  dir: null
  name: user_data
return:
  return: null
  return-values:
  - description: |
      The requested operation was successful.
    value: ${../../status/if/successful:/name}
  - description: |
      The Timer Server was not initiated.
    value: ${../../status/if/incorrect-state:/name}
  - description: |
      The system date and time was not set.
    value: ${../../status/if/not-defined:/name}
  - description: |
      The ${.:/params[2]/name} parameter was ${/c/if/null:/name}.
    value: ${../../status/if/invalid-address:/name}
  - description: |
      The ${.:/params[1]/name} parameter was ${/c/if/null:/name}.
    value: ${../../status/if/invalid-address:/name}
  - description: |
      The time of day was invalid.
    value: ${../../status/if/invalid-clock:/name}
  - description: |
      There was no timer associated with the identifier specified by
      ${.:/params[0]/name}.
    value: ${../../status/if/invalid-id:/name}
type: interface
